Index: XIOS/dev/branch_yushan/src/cxios.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/cxios.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/cxios.cpp	(revision 1037)
@@ -30,9 +30,10 @@
   bool CXios::isOptPerformance = true;
   CRegistry* CXios::globalRegistry = 0;
-  double CXios::recvFieldTimeout = 10.0;
 
   //! Parse configuration file and create some objects from it
   void CXios::initialize()
   {
+    
+    
     set_new_handler(noMemory);
     parseFile(rootFile);
@@ -64,9 +65,27 @@
     bufferSizeFactor = getin<double>("buffer_size_factor", defaultBufferSizeFactor);
     minBufferSize = getin<int>("min_buffer_size", 1024 * sizeof(double));
-    recvFieldTimeout = getin<double>("recv_field_timeout", 10.0);
-    if (recvFieldTimeout < 0.0)
-      ERROR("CXios::parseXiosConfig()", "recv_field_timeout cannot be negative.");
-
-    globalComm=MPI_COMM_WORLD ;
+
+    int num_ep;
+    if(isClient) 
+    { 
+      num_ep = 1;
+    }
+    
+    if(isServer) 
+    { 
+      num_ep = 1; 
+    }
+    
+    MPI_Info info;
+    MPI_Comm *ep_comm;
+    MPI_Comm_create_endpoints(MPI_COMM_WORLD, num_ep, info, ep_comm); 
+      
+    globalComm = ep_comm[0];
+    
+    int tmp_size;
+    MPI_Comm_size(globalComm, &tmp_size);
+    printf("globalcomm size = %d\n", tmp_size);
+
+    
   }
 
@@ -79,8 +98,9 @@
   void CXios::initClientSide(const string& codeId, MPI_Comm& localComm, MPI_Comm& returnComm)
   {
+    isClient = true;
+    
     initialize() ;
 
-    isClient = true;
-
+   
     CClient::initialize(codeId,localComm,returnComm) ;
     if (CClient::getRank()==0) globalRegistry = new CRegistry(returnComm) ;
@@ -89,5 +109,6 @@
     // and the clients are also servers
     isServer = !usingServer;
-
+    
+    
     if (printLogs2Files)
     {
@@ -100,4 +121,6 @@
       CClient::openErrorStream();
     }
+    
+   
   }
 
@@ -123,4 +146,15 @@
   void CXios::initServer()
   {
+    int initialized;
+    MPI_Initialized(&initialized);
+    if (initialized) CServer::is_MPI_Initialized=true ;
+    else CServer::is_MPI_Initialized=false ;
+      
+ 
+    if(!CServer::is_MPI_Initialized)
+    {
+      MPI_Init(NULL, NULL);
+    }
+      
     set_new_handler(noMemory);
     std::set<StdString> parseList;
@@ -133,12 +167,16 @@
   void CXios::initServerSide(void)
   {
-    initServer();
+    
     isClient = false;
     isServer = true;
-
+    
+    initServer();
+    
+    
     // Initialize all aspects MPI
     CServer::initialize();
     if (CServer::getRank()==0) globalRegistry = new CRegistry(CServer::intraComm) ;
     
+      
     if (printLogs2Files)
     {
@@ -151,7 +189,9 @@
       CServer::openErrorStream();
     }
-
+    
     // Enter the loop to listen message from Client
     CServer::eventLoop();
+    
+    printf("server eventloop OK\n");
 
     // Finalize
@@ -162,5 +202,11 @@
        delete globalRegistry ;
      }
+     
+     printf("server globalRegistry OK\n");
+     
     CServer::finalize();
+    
+    printf("server finalize OK\n");
+    
     CServer::closeInfoStream();
   }
Index: XIOS/dev/branch_yushan/src/cxios.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/cxios.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/cxios.hpp	(revision 1037)
@@ -5,4 +5,8 @@
 #include "mpi.hpp"
 #include "registry.hpp"
+#ifdef _usingEP
+//#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
@@ -45,5 +49,4 @@
      static bool isOptPerformance; //!< Check if buffer size is for performance (as large as possible)
      static CRegistry* globalRegistry ; //!< global registry which is wrote by the root process of the servers
-     static double recvFieldTimeout; //!< Time to wait for data before issuing an error when receiving a field
 
     public:
Index: XIOS/dev/branch_yushan/src/dht_auto_indexing.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/dht_auto_indexing.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/dht_auto_indexing.cpp	(revision 1037)
@@ -79,6 +79,5 @@
     for (itIdx = itbIdx; itIdx != iteIdx; ++itIdx)
     {
-//      (itIdx->second)[0] = beginIndexOnProc_ + idx;
-      (itIdx->second)[1] = beginIndexOnProc_ + idx;
+      (itIdx->second)[0] = beginIndexOnProc_ + idx;
       globalIndex_[idx] = beginIndexOnProc_ + idx;
       ++idx ;
Index: XIOS/dev/branch_yushan/src/dht_auto_indexing.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/dht_auto_indexing.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/dht_auto_indexing.hpp	(revision 1037)
@@ -12,4 +12,7 @@
 
 #include "client_client_dht_template.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace xios
Index: XIOS/dev/branch_yushan/src/event_scheduler.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/event_scheduler.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/event_scheduler.hpp	(revision 1037)
@@ -4,4 +4,8 @@
 #include "xios_spl.hpp"
 #include "mpi.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
Index: XIOS/dev/branch_yushan/src/filter/file_writer_filter.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/file_writer_filter.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/file_writer_filter.cpp	(revision 1037)
@@ -2,5 +2,4 @@
 #include "exception.hpp"
 #include "field.hpp"
-#include "utils.hpp"
 
 namespace xios
@@ -17,18 +16,4 @@
   void CFileWriterFilter::onInputReady(std::vector<CDataPacketPtr> data)
   {
-    bool ignoreMissingValue = (!field->detect_missing_value.isEmpty() && 
-                               !field->default_value.isEmpty() && 
-                               field->detect_missing_value == true);
-    if (ignoreMissingValue)
-    {
-      double missingValue = field->default_value;
-      size_t nbData = data[0]->data.numElements();
-      for (size_t idx = 0; idx < nbData; ++idx)
-      {
-        if (NumTraits<double>::isnan(data[0]->data(idx)))
-          data[0]->data(idx) = missingValue;
-      }
-    }    
-
     field->sendUpdateData(data[0]->data);
   }
Index: XIOS/dev/branch_yushan/src/filter/filter.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/filter.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/filter.cpp	(revision 1037)
@@ -5,5 +5,5 @@
   CFilter::CFilter(CGarbageCollector& gc, size_t inputSlotsCount, IFilterEngine* engine)
     : CInputPin(gc, inputSlotsCount)
-    , COutputPin(gc)
+    , COutputPin()
     , engine(engine)
     , inputSlotCount(inputSlotCount)
@@ -14,29 +14,5 @@
     CDataPacketPtr outputPacket = engine->apply(data);
     if (outputPacket)
-      onOutputReady(outputPacket);
-  }
-
-  void CFilter::setInputTrigger(size_t inputSlot, COutputPin* trigger)
-  {
-    // Was the filter already triggerable? If not, we need to inform
-    // all downstream filters.
-    bool wasTriggerable = canBeTriggered();
-
-    CInputPin::setInputTrigger(inputSlot, trigger);
-
-    if (!wasTriggerable)
-      setOutputTriggers();
-  }
-
-  void CFilter::trigger(Time timestamp)
-  {
-    CInputPin::trigger(timestamp);
-
-    COutputPin::trigger(timestamp);
-  }
-
-  bool CFilter::canBeTriggered() const
-  {
-    return (CInputPin::canBeTriggered() || COutputPin::canBeTriggered());
+      deliverOuput(outputPacket);
   }
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/filter.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/filter.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/filter.hpp	(revision 1037)
@@ -26,26 +26,4 @@
       CFilter(CGarbageCollector& gc, size_t inputSlotsCount, IFilterEngine* engine);
 
-      /*!
-       * Sets the trigger for a specific input slot.
-       *
-       * \param inputSlot the input slot number
-       * \param trigger the corresponding trigger
-       */
-      void virtual setInputTrigger(size_t inputSlot, COutputPin* trigger);
-
-      /*!
-       * Triggers the filter for the specified timestamp.
-       *
-       * \param timestamp the timestamp for which we are triggering the filter
-       */
-      void virtual trigger(Time timestamp);
-
-      /*!
-       * Tests if the filter can be triggered.
-       *
-       * \return true if the filter can be triggered
-       */
-      bool virtual canBeTriggered() const;
-
     protected:
       IFilterEngine* engine; //!< The filter engine, might be the filter itself
Index: XIOS/dev/branch_yushan/src/filter/garbage_collector.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/garbage_collector.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/garbage_collector.cpp	(revision 1037)
@@ -3,28 +3,28 @@
 namespace xios
 {
-  void CGarbageCollector::registerObject(InvalidableObject* Object, Time timestamp)
+  void CGarbageCollector::registerFilter(CInputPin* inputPin, Time timestamp)
   {
-    registeredObjects[timestamp].insert(Object);
+    registeredFilters[timestamp].insert(inputPin);
   }
 
-  void CGarbageCollector::unregisterObject(InvalidableObject* Object, Time timestamp)
+  void CGarbageCollector::unregisterFilter(CInputPin* inputPin, Time timestamp)
   {
-    std::map<Time, std::set<InvalidableObject*> >::iterator it = registeredObjects.find(timestamp);
-    if (it != registeredObjects.end())
-      it->second.erase(Object);
+    std::map<Time, std::set<CInputPin*> >::iterator it = registeredFilters.find(timestamp);
+    if (it != registeredFilters.end())
+      it->second.erase(inputPin);
   }
 
   void CGarbageCollector::invalidate(Time timestamp)
   {
-    std::map<Time, std::set<InvalidableObject*> >::iterator it    = registeredObjects.begin(),
-                                                            itEnd = registeredObjects.lower_bound(timestamp);
+    std::map<Time, std::set<CInputPin*> >::iterator it    = registeredFilters.begin(),
+                                                    itEnd = registeredFilters.lower_bound(timestamp);
     for (; it != itEnd; ++it)
     {
-      std::set<InvalidableObject*>::iterator itObject    = it->second.begin(),
-                                             itObjectEnd = it->second.end();
-      for (; itObject != itObjectEnd; ++itObject)
-        (*itObject)->invalidate(timestamp);
+      std::set<CInputPin*>::iterator itFilter    = it->second.begin(),
+                                     itFilterEnd = it->second.end();
+      for (; itFilter != itFilterEnd; ++itFilter)
+        (*itFilter)->invalidate(timestamp);
     }
-    registeredObjects.erase(registeredObjects.begin(), itEnd);
+    registeredFilters.erase(registeredFilters.begin(), itEnd);
   }
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/garbage_collector.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/garbage_collector.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/garbage_collector.hpp	(revision 1037)
@@ -5,21 +5,8 @@
 #include <set>
 
-#include "date.hpp"
+#include "input_pin.hpp"
 
 namespace xios
 {
-  /*!
-   * Interface shared by all objects that might need to invalidate packets.
-   */
-  struct InvalidableObject
-  {
-    /*!
-     * Removes all pending packets which are older than the specified timestamp.
-     *
-     * \param timestamp the timestamp used for invalidation
-     */
-    void virtual invalidate(Time timestamp) = 0;
-  }; // struct InvalidableObject
-
   /*!
    * A basic garbage collector which ensures no old packets linger in the filter graph.
@@ -35,21 +22,21 @@
 
       /*!
-       * Registers an object for a specified timestamp.
+       * Registers a filter for a specified timestamp.
        *
-       * \param object the object to register
-       * \param timestamp the timestamp for which the object is registered
+       * \param inputPin the input pin of the filter to register
+       * \param timestamp the timestamp for which the filter is registered
        */
-      void registerObject(InvalidableObject* object, Time timestamp);
+      void registerFilter(CInputPin* inputPin, Time timestamp);
 
       /*!
-       * Removes a object previously registered for a specified timestamp.
+       * Removes a filter previously registered for a specified timestamp.
        *
-       * \param object the object to unregister
-       * \param timestamp the timestamp for which the object is unregistered
+       * \param inputPin the input pin of the filter to unregister
+       * \param timestamp the timestamp for which the filter is unregistered
        */
-      void unregisterObject(InvalidableObject* object, Time timestamp);
+      void unregisterFilter(CInputPin* inputPin, Time timestamp);
 
       /*!
-       * Ensures all registered objects invalidate packets older than the specified timestamp.
+       * Ensures all registered filters invalidate packets older than the specified timestamp.
        *
        * \param timestamp the timestamp used for invalidation
@@ -61,5 +48,5 @@
       CGarbageCollector& operator=(const CGarbageCollector&);
 
-      std::map<Time, std::set<InvalidableObject*> > registeredObjects; //!< Currently registered objects
+      std::map<Time, std::set<CInputPin*> > registeredFilters; //!< Currently registered filters
   }; // class CGarbageCollector
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/input_pin.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/input_pin.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/input_pin.cpp	(revision 1037)
@@ -1,4 +1,3 @@
 #include "input_pin.hpp"
-#include "output_pin.hpp"
 #include "garbage_collector.hpp"
 #include "exception.hpp"
@@ -9,6 +8,4 @@
     : gc(gc)
     , slotsCount(slotsCount)
-    , triggers(slotsCount)
-    , hasTriggers(false)
   { /* Nothing to do */ }
 
@@ -26,6 +23,7 @@
     {
       it = inputs.insert(std::make_pair(packet->timestamp, InputBuffer(slotsCount))).first;
-      gc.registerObject(this, packet->timestamp);
+      gc.registerFilter(this, packet->timestamp);
     }
+
     it->second.slotsFilled++;
     it->second.packets[inputSlot] = packet;
@@ -34,41 +32,8 @@
     {
       // Unregister before calling onInputReady in case the filter registers again
-      gc.unregisterObject(this, packet->timestamp);
+      gc.unregisterFilter(this, packet->timestamp);
       onInputReady(it->second.packets);
       inputs.erase(it);
     }
-  }
-
-  void CInputPin::setInputTrigger(size_t inputSlot, COutputPin* trigger)
-  {
-    if (inputSlot >= slotsCount)
-      ERROR("void CInputPin::setInputTrigger(size_t inputSlot, COutputPin* trigger)",
-            "The input slot " << inputSlot << " does not exist.");
-    if (triggers[inputSlot])
-      ERROR("void CInputPin::setInputTrigger(size_t inputSlot, COutputPin* trigger)",
-            "The trigger for input slot " << inputSlot << " has already been set.");
-
-    triggers[inputSlot] = trigger;
-    hasTriggers = true;
-  }
-
-  void CInputPin::trigger(Time timestamp)
-  {
-    if (hasTriggers) // Don't use canBeTriggered here, this function is virtual and can be overriden
-    {
-      std::map<Time, InputBuffer>::iterator it = inputs.find(timestamp);
-      bool nothingReceived = (it == inputs.end());
-
-      for (size_t s = 0; s < slotsCount; s++)
-      {
-        if (triggers[s] && (nothingReceived || !it->second.packets[s]))
-          triggers[s]->trigger(timestamp);
-      }
-    }
-  }
-
-  bool CInputPin::canBeTriggered() const
-  {
-    return hasTriggers;
   }
 
Index: XIOS/dev/branch_yushan/src/filter/input_pin.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/input_pin.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/input_pin.hpp	(revision 1037)
@@ -5,15 +5,14 @@
 #include <map>
 
-#include "garbage_collector.hpp"
 #include "data_packet.hpp"
 
 namespace xios
 {
-  class COutputPin;
+  class CGarbageCollector;
 
   /*!
    * An input pin handles the data packets received by a filter.
    */
-  class CInputPin : public InvalidableObject
+  class CInputPin
   {
     public:
@@ -28,12 +27,4 @@
 
       /*!
-       * Sets the trigger for a specific input slot.
-       *
-       * \param inputSlot the input slot number
-       * \param trigger the corresponding trigger
-       */
-      void virtual setInputTrigger(size_t inputSlot, COutputPin* trigger);
-
-      /*!
        * Receives a data packet from an upstream filter on
        * the specified input slot.
@@ -46,18 +37,4 @@
 
       /*!
-       * Triggers the input of any buffered packet for the specified timestamp.
-       *
-       * \param timestamp the timestamp for which we are triggering the input
-       */
-      void virtual trigger(Time timestamp);
-
-      /*!
-       * Tests if the pin can be triggered.
-       *
-       * \return true if the pin can be triggered
-       */
-      bool virtual canBeTriggered() const;
-
-      /*!
        * Removes all pending packets which are older than the specified timestamp.
        *
@@ -67,4 +44,6 @@
 
     protected:
+      CGarbageCollector& gc; //!< The garbage collector associated to the input pin
+
       /*!
        * Function triggered when all slots have been filled for a specific timestamp.
@@ -96,16 +75,8 @@
       };
 
-      CGarbageCollector& gc; //!< The garbage collector associated to the input pin
-
       size_t slotsCount; //!< The number of slots
 
       //! Input buffer, store the packets until all slots are full for a timestep
       std::map<Time, InputBuffer> inputs;
-
-      //! Store the triggers corresponding to the input slots
-      std::vector<COutputPin*> triggers;
-
-      //! Whether some triggers have been set
-      bool hasTriggers;
   }; // class CInputPin
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/output_pin.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/output_pin.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/output_pin.cpp	(revision 1037)
@@ -4,9 +4,4 @@
 namespace xios
 {
-  COutputPin::COutputPin(CGarbageCollector& gc, bool manualTrigger /*= false*/)
-    : gc(gc)
-    , manualTrigger(manualTrigger)
-  { /* Nothing to do */ }
-
   void COutputPin::connectOutput(boost::shared_ptr<CInputPin> inputPin, size_t inputSlot)
   {
@@ -16,22 +11,4 @@
 
     outputs.push_back(std::make_pair(inputPin, inputSlot));
-
-    if (canBeTriggered())
-      inputPin->setInputTrigger(inputSlot, this);
-  }
-
-  void COutputPin::onOutputReady(CDataPacketPtr packet)
-  {
-    if (!packet)
-      ERROR("void COutputPin::onOutputReady(CDataPacketPtr packet)",
-            "The packet cannot be null.");
-
-    if (manualTrigger) // Don't use canBeTriggered here, this function is virtual and can be overriden
-    {
-      outputPackets[packet->timestamp] = packet;
-      gc.registerObject(this, packet->timestamp);
-    }
-    else
-      deliverOuput(packet);
   }
 
@@ -44,36 +21,7 @@
     std::vector<std::pair<boost::shared_ptr<CInputPin>, size_t> >::iterator it, itEnd;
     for (it = outputs.begin(), itEnd = outputs.end(); it != itEnd; ++it)
+    {
       it->first->setInput(it->second, packet);
-  }
-
-  void COutputPin::trigger(Time timestamp)
-  {
-    if (manualTrigger) // Don't use canBeTriggered here, this function is virtual and can be overriden
-    {
-      std::map<Time, CDataPacketPtr>::iterator it = outputPackets.find(timestamp);
-      if (it != outputPackets.end())
-      {
-        gc.unregisterObject(this, timestamp);
-        deliverOuput(it->second);
-        outputPackets.erase(it);
-      }
     }
   }
-
-  bool COutputPin::canBeTriggered() const
-  {
-    return manualTrigger;
-  }
-
-  void COutputPin::setOutputTriggers()
-  {
-    std::vector<std::pair<boost::shared_ptr<CInputPin>, size_t> >::iterator it, itEnd;
-    for (it = outputs.begin(), itEnd = outputs.end(); it != itEnd; ++it)
-      it->first->setInputTrigger(it->second, this);
-  }
-
-  void COutputPin::invalidate(Time timestamp)
-  {
-    outputPackets.erase(outputPackets.begin(), outputPackets.lower_bound(timestamp));
-  }
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/output_pin.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/output_pin.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/output_pin.hpp	(revision 1037)
@@ -2,5 +2,4 @@
 #define __XIOS_COutputPin__
 
-#include "garbage_collector.hpp"
 #include "input_pin.hpp"
 
@@ -10,16 +9,7 @@
    * An output pin handles the connections with downstream filters.
    */
-  class COutputPin : public InvalidableObject
+  class COutputPin
   {
     public:
-      /*!
-       * Constructs an ouput pin with manual or automatic trigger
-       * and an associated garbage collector.
-       *
-       * \param gc the garbage collector associated with this ouput pin
-       * \param slotsCount the number of slots
-       */
-      COutputPin(CGarbageCollector& gc, bool manualTrigger = false);
-
       /*!
        * Connects to a specific slot of the input pin of a downstream filter.
@@ -31,39 +21,5 @@
       void connectOutput(boost::shared_ptr<CInputPin> inputPin, size_t inputSlot);
 
-      /*!
-       * Triggers the output of any buffered packet for the specified timestamp.
-       *
-       * \param timestamp the timestamp for which we are triggering the output
-       */
-      void virtual trigger(Time timestamp);
-
-      /*!
-       * Tests if the pin can be triggered.
-       *
-       * \return true if the pin can be triggered
-       */
-      bool virtual canBeTriggered() const;
-
-      /*!
-       * Removes all pending packets which are older than the specified timestamp.
-       *
-       * \param timestamp the timestamp used for invalidation
-       */
-      void virtual invalidate(Time timestamp);
-
     protected:
-      /*!
-       * Function triggered when a packet is ready to be delivered.
-       *
-       * \param packet the packet ready for output
-       */
-      void onOutputReady(CDataPacketPtr packet);
-
-      /*!
-       * Informs the downstream pins that this output pin should be triggered.
-       */
-      void setOutputTriggers();
-
-    private:
       /*!
        * Delivers an output packet to the downstreams filter.
@@ -73,14 +29,7 @@
       void deliverOuput(CDataPacketPtr packet);
 
-      CGarbageCollector& gc; //!< The garbage collector associated to the output pin
-
-      //!< Whether the ouput should be triggered manually
-      bool manualTrigger;
-
+    private:
       //!< The list of connected filters and the corresponding slot numbers
       std::vector<std::pair<boost::shared_ptr<CInputPin>, size_t> > outputs;
-
-      //! Output buffer, store the packets until the output is triggered
-      std::map<Time, CDataPacketPtr> outputPackets;
   }; // class COutputPin
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/source_filter.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/source_filter.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/source_filter.cpp	(revision 1037)
@@ -3,16 +3,10 @@
 #include "exception.hpp"
 #include "calendar_util.hpp"
-#include <limits> 
 
 namespace xios
 {
-  CSourceFilter::CSourceFilter(CGarbageCollector& gc, CGrid* grid,
-                               const CDuration offset /*= NoneDu*/, bool manualTrigger /*= false*/,
-                               bool hasMissingValue /*= false*/,
-                               double defaultValue /*= 0.0*/)
-    : COutputPin(gc, manualTrigger)
-    , grid(grid)
+  CSourceFilter::CSourceFilter(CGrid* grid, const CDuration offset /*= NoneDu*/)
+    : grid(grid)
     , offset(offset)
-    , hasMissingValue(hasMissingValue), defaultValue(defaultValue)
   {
     if (!grid)
@@ -32,19 +26,8 @@
 
     packet->data.resize(grid->storeIndex_client.numElements());
+
     grid->inputField(data, packet->data);
 
-    // Convert missing values to NaN
-    if (hasMissingValue)
-    {
-      double nanValue = std::numeric_limits<double>::quiet_NaN();
-      size_t nbData = packet->data.numElements();
-      for (size_t idx = 0; idx < nbData; ++idx)
-      {
-        if (defaultValue == packet->data(idx))
-          packet->data(idx) = nanValue;
-      }
-    }
-
-    onOutputReady(packet);
+    deliverOuput(packet);
   }
 
@@ -66,9 +49,8 @@
     packet->status = CDataPacket::NO_ERROR;
 
-    // if (data.size() != grid->storeIndex_toSrv.size())
-    if (data.size() != grid->storeIndex_fromSrv.size())
+    if (data.size() != grid->storeIndex_toSrv.size())
       ERROR("CSourceFilter::streamDataFromServer(CDate date, const std::map<int, CArray<double, 1> >& data)",
             << "Incoherent data received from servers,"
-            << " expected " << grid->storeIndex_fromSrv.size() << " chunks but " << data.size() << " were given.");
+            << " expected " << grid->storeIndex_toSrv.size() << " chunks but " << data.size() << " were given.");
 
     packet->data.resize(grid->storeIndex_client.numElements());
@@ -76,11 +58,11 @@
     for (it = data.begin(); it != itEnd; it++)
     {
-      // CArray<int,1>& index = grid->storeIndex_toSrv[it->first];
-      CArray<int,1>& index = grid->storeIndex_fromSrv[it->first];
+      CArray<int,1>& index = grid->storeIndex_toSrv[it->first];
+
       for (int n = 0; n < index.numElements(); n++)
         packet->data(index(n)) = it->second(n);
     }
 
-    onOutputReady(packet);
+    deliverOuput(packet);
   }
 
@@ -91,5 +73,5 @@
     packet->timestamp = date;
     packet->status = CDataPacket::END_OF_STREAM;
-    onOutputReady(packet);
+    deliverOuput(packet);
   }
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/source_filter.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/source_filter.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/source_filter.hpp	(revision 1037)
@@ -19,15 +19,8 @@
        * Constructs a source filter accepting data attached to the specified grid.
        *
-       * \param gc the garbage collector associated with this filter
        * \param grid the grid to which the data is attached
        * \param offset the offset applied to the timestamp of all packets
-       * \param manualTrigger whether the output should be triggered manually
-       * \param hasMissingValue whether data has missing value
-       * \param defaultValue missing value to detect
        */
-      CSourceFilter(CGarbageCollector& gc, CGrid* grid,
-                    const CDuration offset = NoneDu, bool manualTrigger = false,
-                    bool hasMissingValue = false,
-                    double defaultValue = 0.0);
+      CSourceFilter(CGrid* grid, const CDuration offset = NoneDu);
 
       /*!
@@ -62,6 +55,4 @@
       CGrid* grid; //!< The grid attached to the data the filter can accept
       const CDuration offset; //!< The offset applied to the timestamp of all packets
-      bool hasMissingValue;
-      double defaultValue;
   }; // class CSourceFilter
 } // namespace xios
Index: XIOS/dev/branch_yushan/src/filter/spatial_transform_filter.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/spatial_transform_filter.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/spatial_transform_filter.cpp	(revision 1037)
@@ -11,5 +11,5 @@
 
   std::pair<boost::shared_ptr<CSpatialTransformFilter>, boost::shared_ptr<CSpatialTransformFilter> >
-  CSpatialTransformFilter::buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, bool hasMissingValue, double missingValue)
+  CSpatialTransformFilter::buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, double defaultValue)
   {
     if (!srcGrid || !destGrid)
@@ -26,5 +26,4 @@
       const std::vector<StdString>& auxInputs = gridTransformation->getAuxInputs();
       size_t inputCount = 1 + (auxInputs.empty() ? 0 : auxInputs.size());
-      double defaultValue  = (hasMissingValue) ? std::numeric_limits<double>::quiet_NaN() : missingValue;
       boost::shared_ptr<CSpatialTransformFilter> filter(new CSpatialTransformFilter(gc, engine, defaultValue, inputCount));
 
@@ -54,5 +53,5 @@
     CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue);
     if (outputPacket)
-      onOutputReady(outputPacket);
+      deliverOuput(outputPacket);
   }
 
@@ -104,6 +103,5 @@
       }
       packet->data.resize(gridTransformation->getGridDestination()->storeIndex_client.numElements());
-      if (0 != packet->data.numElements())
-        (packet->data)(0) = defaultValue;
+      packet->data = defaultValue;
       apply(data[0]->data, packet->data);
     }
@@ -220,7 +218,7 @@
     if (dataCurrentDest.numElements() != dataDest.numElements())
     ERROR("CSpatialTransformFilterEngine::apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest)",
-          "Incoherent between the received size and expected size. " << std::endl 
-          << "Expected size: " << dataDest.numElements() << std::endl 
-          << "Received size: " << dataCurrentDest.numElements());
+          "Incoherent between the received size and expected size" <<
+          "Expected size: " << dataDest.numElements() <<
+          "Received size: " << dataCurrentDest.numElements());
 
     dataDest = dataCurrentDest;
Index: XIOS/dev/branch_yushan/src/filter/spatial_transform_filter.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/filter/spatial_transform_filter.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/filter/spatial_transform_filter.hpp	(revision 1037)
@@ -32,10 +32,8 @@
        * \param srcGrid the source grid
        * \param destGrid the destination grid
-       * \param hasMissingValue whether field source has missing value
-       * \param defaultValue default value
        * \return the first and the last filters of the filter graph
        */
       static std::pair<boost::shared_ptr<CSpatialTransformFilter>, boost::shared_ptr<CSpatialTransformFilter> >
-      buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, bool hasMissingValue, double defaultValue);
+      buildFilterGraph(CGarbageCollector& gc, CGrid* srcGrid, CGrid* destGrid, double defaultValue);
 
     protected:
